2 # Validate timeout basic operation
4 # Copyright (C) 2008-2010 Free Software Foundation, Inc.
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 3 of the License, or
9 # (at your option) any later version.
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see <http://www.gnu.org/licenses/>.
19 if test "$VERBOSE" = yes; then
27 timeout
10 true || fail
=1
29 # no timeout (suffix check)
30 timeout
1d true || fail
=1
33 timeout
0 true || fail
=1
35 # exit status propagation
36 timeout
10 sh
-c 'exit 2'
41 test $?
= 124 || fail
=1
43 # kill delay. Note once the initial timeout triggers,
44 # the exit status will be 124 even if the command
45 # exits on its own accord.
46 timeout
-s0 -k1 1 sleep 10
47 test $?
= 124 && fail
=1
49 # Ensure `timeout` is immune to parent's SIGCHLD handler
50 # Use a subshell and an exec to work around a bug in FreeBSD 5.0 /bin/sh.
52 # ash doesn't support "trap '' CHLD"; it knows only signal numbers.
53 sig
=`"$abs_top_builddir/src/kill" -l CHLD 2>/dev/null` && trap '' $sig